/****************************************
 * classe commune a tous les capteurs
 les capteurs doivent etre connecte en input PULL_UP
 utilise la bibliotheque Bounce2
 * constructeur :
 *    une broche ou est relie le capteur
 *    un temps pour la bibliotheque Bounce (optionnel)
 *    un nom de capteur (optionnel)
 * methodes :
 *    int getPin() : renvoie la broche du capteur
 *    String getName() : renvoie le nom du capteur
 *    bool update() : mise a jour du capteur
 *    bool actif() : renvoie si un capteur a changer d'etat
 ***************************************************************************/

#ifndef CAPTEUR_H
#define CAPTEUR_H

#include <Bounce2.h>
#include <Arduino.h>

class capteur
{
    public:
        // les constructeurs
        capteur();
        capteur(int);
        capteur(int,char*);
        capteur(int,int, char*);
        // le destructeur
        virtual ~capteur();
        // renvoie la pin du capteur
        int broche() {return _pin;}
        // renvoie le nom du capteur
        char* nom() {return _nom;}
        // methodes
        bool actif();    // capteur active ou non
        bool actualiser();   // mise a jour du capteur

    protected:
        // la broche du capteur
        int _pin;
        // son nom
        char* _nom;
    private:
        Bounce bounceILS;

};

#endif // CAPTEUR_H
