#ifndef FEUX_H
#define FEUX_H

#include <Arduino.h>

/*****************************************
classe de gestion des feux routiers
constructeurs :
    pin : pin des feux du passage a niveau
    cde : niveau actif des Leds
    duree : duree du pas du fading
methodes :
    int getPin() : renvoie la pin des feux du passage a niveau
    void ON() : allume les feux
    void OFF() : eteint les feux
    bool stateON() : vrai si en phase ON
    bool stateOFF() : vrai si en phase OFF
*********************************************/

class feux
{
    public:
        // les constructeurs
        feux();
        feux(int, bool);
        feux(int, bool, int);
        // le destructeur
        virtual ~feux();
        // renvoie la pin des feux
        int broche(){return _pin;}
        // methode pour allumer les feux
        void ON();
        // methode pour eteindre les feux
        void OFF();
        // etat allume des feux
        bool etatON() {return etat == true;}
        // etat eteint des feux
        bool etatOFF() {return etat == false;}
    protected:

    private:
        int _cde = 0;       // niveau pour lampe allumee ( 0 ou 255)
        int _pin;           //la broche de commande des feux
        int cycle = 0;      // le cycle des feux
        int fading = 10;    // le fading de depart
        int fadingStep = 10;     // le pas de fading des feux
        int fadingTiming = 30;  // duree du fading
        int fadeValue = 10; // evolution du fading
        unsigned long timer = millis(); // tempo des feux
        bool etat = false;  //true : phase ON, false phase OFF
};

#endif // FEUX_H
