#include "pas_a_pas.h"

pas_a_pas::pas_a_pas(): barriere(){}
// le constructeur
pas_a_pas::pas_a_pas(int pina, int pinb, int pinc, int pind,int degre, int vitesse) : barriere(vitesse,4), pin1(pina), pin2(pinb), pin3(pinc), pin4(pind),angle(degre), _vitesse(vitesse){
pas = (int)((512.0/360.0) * angle);
pinMode(pin1, OUTPUT);digitalWrite(pin1,0);
pinMode(pin2, OUTPUT);digitalWrite(pin2,0);
pinMode(pin3, OUTPUT);digitalWrite(pin3,0);
pinMode(pin4, OUTPUT);digitalWrite(pin4,0);
}
// le destructeurs
pas_a_pas::~pas_a_pas(){}

/*****************************************************************
OUVERTURE : methode d'initialisation d'ouverture de la barriere
******************************************************************/

void pas_a_pas::ouverture() {
if (!ouverte()) {
    _actif = true;               // on est actif
    sens = montee;              // on monte les barrieres
    situation = encours;        // manoeuvre en cours
    counter = 0;
    }
}

/*********************************************************************
FERMETURE : methode d'initialisation de la fermeture de la barriere
************************************************************************/

void pas_a_pas::fermeture() {
if (!fermee()) {
    _actif = true;               // on est actif
    sens = descente;            // on descend la barriere
    situation = encours;        // manoeuvre en cours
    counter = 0;
    }
}

/*******************************************************************************
MANOEUVRE : phases de manoeuvre de la barriere (ouverture et fermeture)
*********************************************************************************/

void pas_a_pas::manoeuvre() {
if (_actif){                                         // si on est actif
            switch(sens){                           // suivant le sens (montee, descente)
            case montee : {if (counter < pas){for(int i = 0; i < 8; i++){impulsions(i);delayMicroseconds(_vitesse);} counter++;break;}
                           else {halt();_actif = false; sens = arret; situation = ouvert; break;}
                          }
            case descente : {if (counter < pas){for(int i = 7; i >=0; i--){impulsions(i);delayMicroseconds(_vitesse);} counter++; break;}
                           else {halt();_actif = false; sens = arret; situation = ferme; break;}
                          }
             }
  }
}

/***************************************************************************************
 * HALT : arrete le moteur pas a pas
 **************************************************************************************/
 
void pas_a_pas::halt() {
digitalWrite(pin1,0);
digitalWrite(pin2,0);
digitalWrite(pin3,0);
digitalWrite(pin4,0);
}

/***************************************************************************
 * IMPULSIONS : envoie les huit sequences du moteur pas a pas
 ****************************************************************************/

void pas_a_pas::impulsions(int num)
{
  digitalWrite(pin1, bitRead(phases[num], 0));
  digitalWrite(pin2, bitRead(phases[num], 1));
  digitalWrite(pin3, bitRead(phases[num], 2));
  digitalWrite(pin4, bitRead(phases[num], 3));
}
