#ifndef RELAIS_H
#define RELAIS_H

#include "barriere.h"
#include <Arduino.h>

/*****************************************************
classe qui herite de barrier pour des barrieres avec relais
constructeur :
    pin relais ouvrant
    pin relais fermant
    cde : niveau actif des relais (LOW,HIGH)
    duree : duree d'activation des relais
M�thodes redefinies :
    void ouverture() : ouvre la barriere
    void fermeture() : ferme la barriere
    void manoeuvre() : simulation de la manoeuvre d'ouverture

**********************************************************/

class relais : public barriere
{
    public:
        relais();
        // le constructeur
        relais(int pina, int pinb,bool cde, int duree);
        // le destructeur
        virtual ~relais();
        // methode d'ouverture de la barriere
        void ouverture();
        // methode de fermeture de la barriere
        void fermeture();
        // methode de manoeuvre de la barriere
        void manoeuvre();
       // renvoie les pin de commande des barrieres
        int broche(int num) {switch(num) {
                                case 1 : {return pin1; break;}
                                case 2 : {return pin2;break;}
                                default : return 0;
                                }}

    protected:
    private:
        // pin de commande
        int pin1;
        int pin2;
         // niveau de commande des pins
        int _cde;
};

#endif // RELAIS_H
